The officially official Devuan Forum!

You are not logged in.

#1 2024-04-11 16:40:25

tlathm
Member
Registered: 2017-11-25
Posts: 103  

[SOLVED] Confusion with libcrypt.so.1

I've read all sort of things on this that frankly have my head spinning:

In Beowulf the libc6-i386 package provided the file /lib32/libcrypt.so.1. In Daedalus libc6-i386 no longer does.

However in Daedalus, the package libcrypt1 provides libcrypt.so.1, but only at the path /lib/x86_64-linux-gnu/libcrypt.so.1.

I'm hoping to use a binary executable that requires that and did work under Beowulf, but nothing I try gets it to work. It just complains that libcrypt.so.1 can't be found.

Any clues as to all this? Thanks!
Tom

Offline

#2 2024-04-11 17:57:53

rolfie
Member
Registered: 2017-11-25
Posts: 1,113  

Re: [SOLVED] Confusion with libcrypt.so.1

I guess you are on amd64, a 64-bit system. Your application is a 32 bit application that requires a 32 bit library. You will need to enable i386 as architecture, if you haven't done so far, and then to install the 32 bit version of libcrypt1. Same procedure as for wine32.

# dpkg --add-architecture i386
# apt update
# apt upgrade
# dpkg -print-foreign-architectures
# apt policy libcrypt1

Offline

#3 2024-04-11 19:36:07

tlathm
Member
Registered: 2017-11-25
Posts: 103  

Re: [SOLVED] Confusion with libcrypt.so.1

Thanks! Will give that a try.

Tom

Offline

#4 2024-04-11 20:16:55

tlathm
Member
Registered: 2017-11-25
Posts: 103  

Re: [SOLVED] Confusion with libcrypt.so.1

Odd. I did all the above. What I don't quite understand is that the "apt upgrade" didn't update or install anything, and the executable I'm trying to run still can't find libcrypt.so.1. Here are some outputs:

dpkg --print-foreign-architectures
i386

apt policy libcrypt1
libcrypt1:
  Installed: 1:4.4.33-2
  Candidate: 1:4.4.33-2
  Version table:
 *** 1:4.4.33-2 500
        500 http://deb.devuan.org/merged daedalus/main amd64 Packages
        100 /var/lib/dpkg/status

dpkg -L libcrypt1
/.
/lib
/lib/x86_64-linux-gnu
/lib/x86_64-linux-gnu/libcrypt.so.1.1.0
/usr
/usr/share
/usr/share/doc
/usr/share/doc/libcrypt1
/usr/share/doc/libcrypt1/changelog.Debian.gz
/usr/share/doc/libcrypt1/changelog.gz
/usr/share/doc/libcrypt1/copyright
/lib/x86_64-linux-gnu/libcrypt.so.1

Here's the ldd output of the executable:

	linux-gate.so.1 (0xf7edb000)
	libnsl.so.1 => /lib32/libnsl.so.1 (0xf7eb3000)
	libdl.so.2 => /lib32/libdl.so.2 (0xf7eae000)
	libm.so.6 => /lib32/libm.so.6 (0xf7da9000)
	libcrypt.so.1 => not found
	libutil.so.1 => /lib32/libutil.so.1 (0xf7da4000)
	libpthread.so.0 => /lib32/libpthread.so.0 (0xf7d9f000)
	libc.so.6 => /lib32/libc.so.6 (0xf7a00000)
	/lib/ld-linux.so.2 (0xf7edd000)

As you can see that's still not found. Any ideas? Thanks!

Tom

Offline

#5 2024-04-11 21:27:08

rolfie
Member
Registered: 2017-11-25
Posts: 1,113  

Re: [SOLVED] Confusion with libcrypt.so.1

Well apt policy did not show the 32 bit version. Give

# apt list libcrypt1 -a 

a try.

Normally the 32bit version cab be installed by:

# apt install libcrypt1:i386

Last edited by rolfie (2024-04-11 21:31:33)

Offline

#6 2024-04-11 23:47:10

tlathm
Member
Registered: 2017-11-25
Posts: 103  

Re: [SOLVED] Confusion with libcrypt.so.1

Yes! That worked and got it running! In fact I was able to resolve a similar issue with another executable I had that required libstdc++5:i386.

Thanks a million!
Tom

Offline

Board footer